"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function guard(func, defaultValue) {
    try {
        return func();
    }
    catch (error) {
        return defaultValue;
    }
}
exports.guard = guard;
/** 解析绝对路径$ref */
function resolveRef(rootData, refObject) {
    return guard(() => {
        let result = refObject;
        if (refObject.$ref) {
            const refPaths = refObject.$ref.split('/');
            if (refPaths[0] === '#') {
                refPaths.shift();
                let obj = rootData;
                refPaths.forEach((node) => {
                    obj = obj[node];
                });
                result = Object.assign({}, obj);
                // FIXME 防止循环引用
                return result;
            }
        }
        Object.keys(result).forEach(key => {
            if (typeof result[key] === 'object') {
                result[key] = resolveRef(rootData, result[key]);
            }
        });
        return result;
    }, refObject);
}
exports.resolveRef = resolveRef;
